import { getNotificationContainer } from '../notification-util';
/**
 * Shows the notificationStructure
 * @internal
 * @param notificationStructure - The NotificationStructure object
 * @param tagName - The tag name to create prefix for the design system provider & notificationStructure component
 * @returns
 * */
export const showToast = (notificationStructure, tagName) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
    const tagPrefix = tagName.split('-')[0];
    const container = getNotificationContainer('notify-container', tagName);
    if (container) {
        container.style.position = 'fixed';
        switch ((_b = (_a = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _a === void 0 ? void 0 : _a.toast) === null || _b === void 0 ? void 0 : _b.position) {
            case 'top-left':
                container.style.top = '0';
                container.style.left = '0';
                break;
            case 'bottom-left':
                container.style.bottom = '0';
                container.style.left = '0';
                break;
            case 'bottom-right':
                container.style.bottom = '0';
                container.style.right = '0';
                break;
            default:
                container.style.top = '0';
                container.style.right = '0';
        }
    }
    const toastNotify = document.createElement(`${tagPrefix}-toast`);
    const toastTitle = document.createElement('div');
    toastTitle.setAttribute('slot', 'top');
    toastTitle.textContent = notificationStructure.title;
    const toastDetails = document.createElement('div');
    toastDetails.setAttribute('slot', 'content');
    toastDetails.textContent = (notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.body) || '';
    const toastDate = document.createElement('div');
    toastDate.setAttribute('slot', 'date');
    toastDate.textContent = new Date().toLocaleTimeString();
    let toastBottom;
    if (((_d = (_c = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _c === void 0 ? void 0 : _c.toast) === null || _d === void 0 ? void 0 : _d.buttons) &&
        ((_g = (_f = (_e = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _e === void 0 ? void 0 : _e.toast) === null || _f === void 0 ? void 0 : _f.buttons) === null || _g === void 0 ? void 0 : _g.length)) {
        toastBottom = document.createElement('div');
        toastBottom.setAttribute('slot', 'bottom');
        notificationStructure.config.toast.buttons.forEach((button) => {
            const elementButton = document.createElement(`${tagPrefix}-button`);
            elementButton.textContent = button.placeholder || 'example placeholder';
            elementButton.addEventListener('click', () => {
                const { details } = notificationStructure.config.toast;
                if (button.action) {
                    return button.action({
                        details,
                        elementButton,
                        elementToast: toastNotify,
                    });
                }
            });
            if (button.appearance) {
                elementButton.setAttribute('appearance', button.appearance);
            }
            toastBottom.appendChild(elementButton);
        });
    }
    toastNotify.setAttribute('notify', ((_j = (_h = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _h === void 0 ? void 0 : _h.toast) === null || _j === void 0 ? void 0 : _j.type) || '');
    ((_l = (_k = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _k === void 0 ? void 0 : _k.toast) === null || _l === void 0 ? void 0 : _l.autoClose)
        ? toastNotify.setAttribute('auto-close', `${(_o = (_m = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _m === void 0 ? void 0 : _m.toast) === null || _o === void 0 ? void 0 : _o.autoClose}`)
        : '';
    ((_q = (_p = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _p === void 0 ? void 0 : _p.toast) === null || _q === void 0 ? void 0 : _q.closeTimeout)
        ? toastNotify.setAttribute('close-timeout', `${(_s = (_r = notificationStructure === null || notificationStructure === void 0 ? void 0 : notificationStructure.config) === null || _r === void 0 ? void 0 : _r.toast) === null || _s === void 0 ? void 0 : _s.closeTimeout}`)
        : '';
    toastNotify.appendChild(toastTitle);
    toastNotify.appendChild(toastDetails);
    toastNotify.appendChild(toastDate);
    if (toastBottom) {
        toastNotify.appendChild(toastBottom);
    }
    container.appendChild(toastNotify);
};
